% num = match(image1, image2)
%
% This function reads two images, finds their SIFT features, and
%   displays lines connecting the matched keypoints.  A match is accepted
%   only if its distance is less than distRatio times the distance to the
%   second closest match.
% It returns the number of matches displayed.
%
% Example: match('scene.pgm','book.pgm');

function num = draw_match(im1,im2,loc1,loc2,m,label)

    %im1 = rgb2gray(im1);
    %im2 = rgb2gray(im2);
    
    %loc1=loc1';
    %loc2=loc2';


    
    
% Create a new image showing the two images side by side.

im2_ori=im2;
loc2_ori=loc2;
if (size(im2,1) ~= size(im1,1)) || (size(im2,2) ~= size(im1,2))
    sx=double(size(im2,1))/double(size(im1,1));
    sy=double(size(im2,2))/double(size(im1,2));
    im2=imresize(im2,[size(im1,1) size(im1,2)]);
    loc2(:,1)=loc2(:,1)/sx;
    loc2(:,2)=loc2(:,2)/sy;
end

im3 = appendimages(im1,im2);

imshow(im3,'border','tight');

% Show a figure with lines joining the accepted matches.
%figure('Position', [0 0 size(im3,2) size(im3,1)]);
grid off;
%axis ([0 size(im3,1) 0 size(im3,2)]);

colormap('gray');

%imagesc(im3);
%hold on;
cols1 = size(im1,2);

for i = 1: size(m,1)

%line([1716 1716+cols1+500],[1103 1103],'Color','c');
    if size(label)==0
        line([loc1(m(i,1),1) loc2(m(i,2),1)+cols1+500], ...
         [loc1(m(i,1),2) loc2(m(i,2),2)], 'Color', 'c');
    else
        if label(i)==0
            color=[0 0 0];
        end
        if label(i)==4
            color=[0.6 0.6 0.6];
        end
        if label(i)==1
            color=[0 1 0];
        end
        if label(i)==2
            color=[0 0 1];
        end
        if label(i)==3
            color=[1 0 0];
        end
        
        line([loc1(m(i,1),1) loc2(m(i,2),1)+cols1+500], ...
         [loc1(m(i,1),2) loc2(m(i,2),2)], 'Color', color);
        
    end
    
end

hold off;
grid off

