%input image
%output 

function [ output_args ] = gen_SIFT( file_name,p1,p2 )

if nargin==1
	p1=4;
    p2=9;
end

[pathstr,name,ext]=fileparts(file_name);

ext_0 = {'*.bmp','*.jpg'}; 

if size(ext) == [0 0]
    a = exist(file_name,'dir');
    if a == 0 
        display('gen_SIFT   ERROR: no such folder');
        return;
    else 
        images = [];  
        for i = 1:length(ext_0)  
            images = [images dir([file_name ext_0{i}])];  
        end  
        for i = 1:length(images)  
            gen_SIFT([file_name images(i).name],p1,p2);  
            fprintf('*');
        end  
        
        
    end
    fprintf('\n');
    
else

if strcmpi(ext,'.jpg') == 0 && strcmpi(ext,'.bmp') == 0
    display('gen_SIFT   ERROR: not .jpg/.bmp file');
    return;
end

if ~exist('vl_version') == 1 
    vl_setup;
end

image = imread(file_name);

image = single(rgb2gray(image)) ;

[f,d] = vl_sift(image, 'PeakThresh', p1,'edgethresh', p2);

if length(pathstr) ~= 0
    pathstr = strcat(pathstr,filesep);
end

f_name = strcat(strcat(pathstr,name),'.mat');

save(f_name,'f','d') ;

end


end

