function residuals = reprojectionResidual_group_err(ObsIdx,ObsVal,px,py,f,Mot,Str,Group)

global nG nP 
disp('rp_ERROR')
% (Constant) ObsIdx: index of KxN for N points observed by K cameras, sparse matrix
% (Constant) ObsVal: 2xM for M observations
% px,py: princple points in pixels
% f: focal length in pixels
% Mot: 3x2xK for K cameras
% Str: 3xN for N points

nCam = size(ObsIdx,1);

if nargin==5
    [Mot,Str,Group,f] = unpackMotStrf_group_f(nCam,nG,nP,f);
elseif nargin==6
    [Mot,Str,Group]   = unpackMotStrf_group(nCam,nG,nP,Mot);
end



%Mot = reshape(Mot,3,2,[]);
%Str = reshape(Str,3,[]);

%residuals = zeros(nCam,nG,nP);

for c=1:nCam
    validPts = ObsIdx(c,:)~=0;
    validIdx = ObsIdx(c,validPts);
    
    for gro=1:nG

    RP = AngleAxisRotatePts(Mot(:,1,c,gro), Str(:,validPts));
    
    TRX = RP(1,:) + Mot(1,2,c,gro);
    TRY = RP(2,:) + Mot(2,2,c,gro);
    TRZ = RP(3,:) + Mot(3,2,c,gro);
    
    TRXoZ = TRX./TRZ;
    TRYoZ = TRY./TRZ;
    
    x = f(c)*TRXoZ + px;
    y = f(c)*TRYoZ + py;
    
    ox = ObsVal(1,validIdx);
    oy = ObsVal(2,validIdx);
    
    %residuals = residuals+sum((((x-ox).^2+(y-oy).^2)));
    %residuals = residuals+Group(gro,:).*(((x-ox).^2+(y-oy).^2));
    
    residuals(c,gro,1,:)=x;
    residuals(c,gro,2,:)=y;
    
    end
    
end

